 %dcl #_glut_h__ char ext;
 %if #_glut_h__ = '' %then %do;
 %#_glut_h__ = 'Y';

 %dcl GLUT_API_VERSION         fixed ext;
 %dcl GLUT_XLIB_IMPLEMENTATION fixed ext;

 /*********************************************************************/
 /* Copyright (c) Mark J. Kilgard, 1994, 1995, 1996, 1998.            */
 /* Translation of header file to PL/I, Mark Yudkin 1999              */
 /*                                                                   */
 /* This program is freely distributable without licensing fees and   */
 /* is provided without guarantee or warrantee expressed or implied.  */
 /* This program is -not- in the public domain.                       */
 /*********************************************************************/

 /*********************************************************************/
 /* Usage note:                                                       */
 /*                                                                   */
 /* GLUT is not supplied in the Microsoft OpenGL implementation       */
 /* You will need to download glut32.dll and glut32.lib from          */
 /* http://www.opengl.org.                                            */
 /* Note that you need the GLUT version that links against the        */
 /* Microsoft OpenGL implementation.                                  */
 /*********************************************************************/

 %dcl #_gl_h_ char ext;
 %if #_gl_h_ = '' %then %do;
 %include gl;
 %end;
 %dcl #_glu_h__ char ext;
 %if #_glu_h__ = '' %then %do;
 %include glu;
 %end;

 /*********************************************************************/
 /* GLUT API revision history:                                        */
 /*                                                                   */
 /* GLUT_API_VERSION is updated to reflect incompatible GLUT          */
 /* API changes (interface changes, semantic changes, deletions,      */
 /* or additions).                                                    */
 /*                                                                   */
 /* GLUT_API_VERSION=1  First public release of GLUT.  11/29/94       */
 /*                                                                   */
 /* GLUT_API_VERSION=2  Added support for OpenGL/GLX multisampling,   */
 /* extension. Supports new input devices like tablet, dial and button*/
 /* box, and Spaceball. Easy to query OpenGL extensions.              */
 /*                                                                   */
 /* GLUT_API_VERSION=3  glutMenuStatus added.                         */
 /*                                                                   */
 /* GLUT_API_VERSION=4  glutInitDisplayString, glutWarpPointer,       */
 /* glutBitmapLength, glutStrokeLength, glutWindowStatusFunc, dynamic */
 /* video resize subAPI, glutPostWindowRedisplay, glutKeyboardUpFunc, */
 /* glutSpecialUpFunc, glutIgnoreKeyRepeat, glutSetKeyRepeat,         */
 /* glutJoystickFunc, glutForceJoystickFunc (NOT FINALIZED!).         */
 /*********************************************************************/

 %if GLUT_API_VERSION = 0 %then %do;
 %GLUT_API_VERSION = 3;
 %end;

 /*********************************************************************/
 /* GLUT implementation revision history:                             */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION is updated to reflect both GLUT          */
 /* API revisions and implementation revisions (ie, bug fixes).       */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=1  mjk's first public release of         */
 /* GLUT Xlib-based implementation.  11/29/94                         */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=2  mjk's second public release of        */
 /* GLUT Xlib-based implementation providing GLUT version 2 interfaces*/
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=3  mjk's GLUT 2.2 images. 4/17/95        */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=4  mjk's GLUT 2.3 images. 6/?/95         */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=5  mjk's GLUT 3.0 images. 10/?/95        */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=7  mjk's GLUT 3.1+ with glutWarpPointer. */
 /*                             7/24/96                               */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=8  mjk's GLUT 3.1+ with glutWarpPointer  */
 /* and video resize.  1/3/97                                         */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=9  mjk's GLUT 3.4 release with early     */
 /*                             GLUT 4 routines.                      */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=11 Mesa 2.5's GLUT 3.6 release.          */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=12 mjk's GLUT 3.6 release with early     */
 /*                             GLUT 4 routines + signal handling.    */
 /*                                                                   */
 /* GLUT_XLIB_IMPLEMENTATION=13 mjk's GLUT 3.7 release with GameGLUT  */
 /*                             support.                              */
 /*********************************************************************/

 %if GLUT_XLIB_IMPLEMENTATION = 0 %then %do;
 %GLUT_XLIB_IMPLEMENTATION = 13;
 %end;

 %dcl GLUTENTRY char ext;
 %GLUTENTRY = 'options (byvalue linkage(stdcall) nodescriptor)';

 /* Display mode bit masks. */
 dcl GLUT_RGB                 fixed bin(31) value(0);
 dcl GLUT_RGBA                fixed bin(31) value (GLUT_RGB);
 dcl GLUT_INDEX               fixed bin(31) value(1);
 dcl GLUT_SINGLE              fixed bin(31) value(0);
 dcl GLUT_DOUBLE              fixed bin(31) value(2);
 dcl GLUT_ACCUM               fixed bin(31) value(4);
 dcl GLUT_ALPHA               fixed bin(31) value(8);
 dcl GLUT_DEPTH               fixed bin(31) value(16);
 dcl GLUT_STENCIL             fixed bin(31) value(32);
 %if GLUT_API_VERSION >= 2 %then %do;
 dcl GLUT_MULTISAMPLE         fixed bin(31) value(128);
 dcl GLUT_STEREO              fixed bin(31) value(256);
 %end;
 %if GLUT_API_VERSION >= 3 %then %do;
 dcl GLUT_LUMINANCE           fixed bin(31) value(512);
 %end;

 /* Mouse buttons. */
 dcl GLUT_LEFT_BUTTON         fixed bin(31) value(0);
 dcl GLUT_MIDDLE_BUTTON       fixed bin(31) value(1);
 dcl GLUT_RIGHT_BUTTON        fixed bin(31) value(2);

 /* Mouse button  state. */
 dcl GLUT_DOWN                fixed bin(31) value(0);
 dcl GLUT_UP                  fixed bin(31) value(1);

 %if GLUT_API_VERSION >= 2 %then %do;
 /* function keys */
 dcl GLUT_KEY_F1              fixed bin(31) value(1);
 dcl GLUT_KEY_F2              fixed bin(31) value(2);
 dcl GLUT_KEY_F3              fixed bin(31) value(3);
 dcl GLUT_KEY_F4              fixed bin(31) value(4);
 dcl GLUT_KEY_F5              fixed bin(31) value(5);
 dcl GLUT_KEY_F6              fixed bin(31) value(6);
 dcl GLUT_KEY_F7              fixed bin(31) value(7);
 dcl GLUT_KEY_F8              fixed bin(31) value(8);
 dcl GLUT_KEY_F9              fixed bin(31) value(9);
 dcl GLUT_KEY_F10             fixed bin(31) value(10);
 dcl GLUT_KEY_F11             fixed bin(31) value(11);
 dcl GLUT_KEY_F12             fixed bin(31) value(12);
 /* directional keys */
 dcl GLUT_KEY_LEFT            fixed bin(31) value(100);
 dcl GLUT_KEY_UP              fixed bin(31) value(101);
 dcl GLUT_KEY_RIGHT           fixed bin(31) value(102);
 dcl GLUT_KEY_DOWN            fixed bin(31) value(103);
 dcl GLUT_KEY_PAGE_UP         fixed bin(31) value(104);
 dcl GLUT_KEY_PAGE_DOWN       fixed bin(31) value(105);
 dcl GLUT_KEY_HOME            fixed bin(31) value(106);
 dcl GLUT_KEY_END             fixed bin(31) value(107);
 dcl GLUT_KEY_INSERT          fixed bin(31) value(108);
 %end;

 /* Entry/exit  state. */
 dcl GLUT_LEFT                fixed bin(31) value(0);
 dcl GLUT_ENTERED             fixed bin(31) value(1);

 /* Menu usage  state. */
 dcl GLUT_MENU_NOT_IN_USE     fixed bin(31) value(0);
 dcl GLUT_MENU_IN_USE         fixed bin(31) value(1);

 /* Visibility  state. */
 dcl GLUT_NOT_VISIBLE         fixed bin(31) value(0);
 dcl GLUT_VISIBLE             fixed bin(31) value(1);

 /* Window status  state. */
 dcl GLUT_HIDDEN              fixed bin(31) value(0);
 dcl GLUT_FULLY_RETAINED      fixed bin(31) value(1);
 dcl GLUT_PARTIALLY_RETAINED  fixed bin(31) value(2);
 dcl GLUT_FULLY_COVERED       fixed bin(31) value(3);

 /* Color index component selection values. */
 dcl GLUT_RED                 fixed bin(31) value(0);
 dcl GLUT_GREEN               fixed bin(31) value(1);
 dcl GLUT_BLUE                fixed bin(31) value(2);

 /* Layers for use. */
 dcl GLUT_NORMAL              fixed bin(31) value(0);
 dcl GLUT_OVERLAY             fixed bin(31) value(1);

 /* Win32 Stroke font constants (use these in GLUT program). */
 dcl GLUT_STROKE_ROMAN          pointer value(ptrvalue(0));
 dcl GLUT_STROKE_MONO_ROMAN     pointer value(ptrvalue(1));

 /* Win32 Bitmap font constants (use these in GLUT program). */
 dcl GLUT_BITMAP_9_BY_15        pointer value(ptrvalue(2));
 dcl GLUT_BITMAP_8_BY_13        pointer value(ptrvalue(3));
 dcl GLUT_BITMAP_TIMES_ROMAN_10 pointer value(ptrvalue(4));
 dcl GLUT_BITMAP_TIMES_ROMAN_24 pointer value(ptrvalue(5));
 %if GLUT_API_VERSION >= 3 %then %do;
 dcl GLUT_BITMAP_HELVETICA_10   pointer value(ptrvalue(6));
 dcl GLUT_BITMAP_HELVETICA_12   pointer value(ptrvalue(7));
 dcl GLUT_BITMAP_HELVETICA_18   pointer value(ptrvalue(8));
 %end;

 /* glutGet parameters. */
 dcl GLUT_WINDOW_X                  fixed bin(31) value(100);
 dcl GLUT_WINDOW_Y                  fixed bin(31) value(101);
 dcl GLUT_WINDOW_WIDTH              fixed bin(31) value(102);
 dcl GLUT_WINDOW_HEIGHT             fixed bin(31) value(103);
 dcl GLUT_WINDOW_BUFFER_SIZE        fixed bin(31) value(104);
 dcl GLUT_WINDOW_STENCIL_SIZE       fixed bin(31) value(105);
 dcl GLUT_WINDOW_DEPTH_SIZE         fixed bin(31) value(106);
 dcl GLUT_WINDOW_RED_SIZE           fixed bin(31) value(107);
 dcl GLUT_WINDOW_GREEN_SIZE         fixed bin(31) value(108);
 dcl GLUT_WINDOW_BLUE_SIZE          fixed bin(31) value(109);
 dcl GLUT_WINDOW_ALPHA_SIZE         fixed bin(31) value(110);
 dcl GLUT_WINDOW_ACCUM_RED_SIZE     fixed bin(31) value(111);
 dcl GLUT_WINDOW_ACCUM_GREEN_SIZE   fixed bin(31) value(112);
 dcl GLUT_WINDOW_ACCUM_BLUE_SIZE    fixed bin(31) value(113);
 dcl GLUT_WINDOW_ACCUM_ALPHA_SIZE   fixed bin(31) value(114);
 dcl GLUT_WINDOW_DOUBLEBUFFER       fixed bin(31) value(115);
 dcl GLUT_WINDOW_RGBA               fixed bin(31) value(116);
 dcl GLUT_WINDOW_PARENT             fixed bin(31) value(117);
 dcl GLUT_WINDOW_NUM_CHILDREN       fixed bin(31) value(118);
 dcl GLUT_WINDOW_COLORMAP_SIZE      fixed bin(31) value(119);
 %if GLUT_API_VERSION >= 2 %then %do;
 dcl GLUT_WINDOW_NUM_SAMPLES        fixed bin(31) value(120);
 dcl GLUT_WINDOW_STEREO             fixed bin(31) value(121);
 %end;
 %if GLUT_API_VERSION >= 3 %then %do;
 dcl GLUT_WINDOW_CURSOR             fixed bin(31) value(122);
 %end;
 dcl GLUT_SCREEN_WIDTH              fixed bin(31) value(200);
 dcl GLUT_SCREEN_HEIGHT             fixed bin(31) value(201);
 dcl GLUT_SCREEN_WIDTH_MM           fixed bin(31) value(202);
 dcl GLUT_SCREEN_HEIGHT_MM          fixed bin(31) value(203);
 dcl GLUT_MENU_NUM_ITEMS            fixed bin(31) value(300);
 dcl GLUT_DISPLAY_MODE_POSSIBLE     fixed bin(31) value(400);
 dcl GLUT_INIT_WINDOW_X             fixed bin(31) value(500);
 dcl GLUT_INIT_WINDOW_Y             fixed bin(31) value(501);
 dcl GLUT_INIT_WINDOW_WIDTH         fixed bin(31) value(502);
 dcl GLUT_INIT_WINDOW_HEIGHT        fixed bin(31) value(503);
 dcl GLUT_INIT_DISPLAY_MODE         fixed bin(31) value(504);
 %if GLUT_API_VERSION >= 2 %then %do;
 dcl GLUT_ELAPSED_TIME              fixed bin(31) value(700);
 %end;
 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 13 %then %do;
 dcl GLUT_WINDOW_FORMAT_ID          fixed bin(31) value(123);
 %end;

 %if GLUT_API_VERSION >= 2 %then %do;
 /* glutDeviceGet parameters. */
 dcl GLUT_HAS_KEYBOARD              fixed bin(31) value(600);
 dcl GLUT_HAS_MOUSE                 fixed bin(31) value(601);
 dcl GLUT_HAS_SPACEBALL             fixed bin(31) value(602);
 dcl GLUT_HAS_DIAL_AND_BUTTON_BOX   fixed bin(31) value(603);
 dcl GLUT_HAS_TABLET                fixed bin(31) value(604);
 dcl GLUT_NUM_MOUSE_BUTTONS         fixed bin(31) value(605);
 dcl GLUT_NUM_SPACEBALL_BUTTONS     fixed bin(31) value(606);
 dcl GLUT_NUM_BUTTON_BOX_BUTTONS    fixed bin(31) value(607);
 dcl GLUT_NUM_DIALS                 fixed bin(31) value(608);
 dcl GLUT_NUM_TABLET_BUTTONS        fixed bin(31) value(609);
 %end;
 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 13 %then %do;
 dcl GLUT_DEVICE_IGNORE_KEY_REPEAT  fixed bin(31) value(610);
 dcl GLUT_DEVICE_KEY_REPEAT         fixed bin(31) value(611);
 dcl GLUT_HAS_JOYSTICK              fixed bin(31) value(612);
 dcl GLUT_OWNS_JOYSTICK             fixed bin(31) value(613);
 dcl GLUT_JOYSTICK_BUTTONS          fixed bin(31) value(614);
 dcl GLUT_JOYSTICK_AXES             fixed bin(31) value(615);
 dcl GLUT_JOYSTICK_POLL_RATE        fixed bin(31) value(616);
 %end;

 %if GLUT_API_VERSION >= 3 %then %do;
 /* glutLayerGet parameters. */
 dcl GLUT_OVERLAY_POSSIBLE          fixed bin(31) value(800);
 dcl GLUT_LAYER_IN_USE              fixed bin(31) value(801);
 dcl GLUT_HAS_OVERLAY               fixed bin(31) value(802);
 dcl GLUT_TRANSPARENT_INDEX         fixed bin(31) value(803);
 dcl GLUT_NORMAL_DAMAGED            fixed bin(31) value(804);
 dcl GLUT_OVERLAY_DAMAGED           fixed bin(31) value(805);

 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 9 %then %do;
 /* glutVideoResizeGet parameters. */
 dcl GLUT_VIDEO_RESIZE_POSSIBLE     fixed bin(31) value(900);
 dcl GLUT_VIDEO_RESIZE_IN_USE       fixed bin(31) value(901);
 dcl GLUT_VIDEO_RESIZE_X_DELTA      fixed bin(31) value(902);
 dcl GLUT_VIDEO_RESIZE_Y_DELTA      fixed bin(31) value(903);
 dcl GLUT_VIDEO_RESIZE_WIDTH_DELTA  fixed bin(31) value(904);
 dcl GLUT_VIDEO_RESIZE_HEIGHT_DELTA fixed bin(31) value(905);
 dcl GLUT_VIDEO_RESIZE_X            fixed bin(31) value(906);
 dcl GLUT_VIDEO_RESIZE_Y            fixed bin(31) value(907);
 dcl GLUT_VIDEO_RESIZE_WIDTH        fixed bin(31) value(908);
 dcl GLUT_VIDEO_RESIZE_HEIGHT       fixed bin(31) value(909);
 %end;

 /* glutUseLayer parameters. */
 /*  GLUT_NORMAL                    fixed bin(31) value(0) */
 /*  GLUT_OVERLAY                   fixed bin(31) value(1) */

 /* glutGetModifiers return mask. */
 dcl GLUT_ACTIVE_SHIFT              fixed bin(31) value(1);
 dcl GLUT_ACTIVE_CTRL               fixed bin(31) value(2);
 dcl GLUT_ACTIVE_ALT                fixed bin(31) value(4);

 /* glutSetCursor parameters. */
 /* Basic arrows. */
 dcl GLUT_CURSOR_RIGHT_ARROW         fixed bin(31) value(0);
 dcl GLUT_CURSOR_LEFT_ARROW          fixed bin(31) value(1);
 /* Symbolic cursor shapes. */
 dcl GLUT_CURSOR_INFO                fixed bin(31) value(2);
 dcl GLUT_CURSOR_DESTROY             fixed bin(31) value(3);
 dcl GLUT_CURSOR_HELP                fixed bin(31) value(4);
 dcl GLUT_CURSOR_CYCLE               fixed bin(31) value(5);
 dcl GLUT_CURSOR_SPRAY               fixed bin(31) value(6);
 dcl GLUT_CURSOR_WAIT                fixed bin(31) value(7);
 dcl GLUT_CURSOR_TEXT                fixed bin(31) value(8);
 dcl GLUT_CURSOR_CROSSHAIR           fixed bin(31) value(9);
 /* Directional cursors. */
 dcl GLUT_CURSOR_UP_DOWN             fixed bin(31) value(10);
 dcl GLUT_CURSOR_LEFT_RIGHT          fixed bin(31) value(11);
 /* Sizing cursors. */
 dcl GLUT_CURSOR_TOP_SIDE            fixed bin(31) value(12);
 dcl GLUT_CURSOR_BOTTOM_SIDE         fixed bin(31) value(13);
 dcl GLUT_CURSOR_LEFT_SIDE           fixed bin(31) value(14);
 dcl GLUT_CURSOR_RIGHT_SIDE          fixed bin(31) value(15);
 dcl GLUT_CURSOR_TOP_LEFT_CORNER     fixed bin(31) value(16);
 dcl GLUT_CURSOR_TOP_RIGHT_CORNER    fixed bin(31) value(17);
 dcl GLUT_CURSOR_BOTTOM_RIGHT_CORNER fixed bin(31) value(18);
 dcl GLUT_CURSOR_BOTTOM_LEFT_CORNER  fixed bin(31) value(19);
 /* Inherit from parent window. */
 dcl GLUT_CURSOR_INHERIT             fixed bin(31) value(100);
 /* Blank cursor. */
 dcl GLUT_CURSOR_NONE                fixed bin(31) value(101);
 /* Fullscreen crosshair (if available). */
 dcl GLUT_CURSOR_FULL_CROSSHAIR      fixed bin(31) value(102);
 %end;

 /* GLUT initialization sub-API. */
 dcl glutInit
     entry (fixed bin (31) byaddr,
            (*) pointer byaddr) /* each to char (*) varz */
     GLUTENTRY external('glutInit');

 dcl glutInitDisplayMode
     entry (fixed bin(32) unsigned)
     GLUTENTRY external('glutInitDisplayMode');

 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 9 %then %do;
 dcl glutInitDisplayString
     entry (char(*) varz byaddr nonasgn)
     GLUTENTRY external('glutInitDisplayString');
 %end;

 dcl glutInitWindowPosition
     entry (fixed bin(31),
            fixed bin(31))
     GLUTENTRY external('glutInitWindowPosition');

 dcl glutInitWindowSize
     entry (fixed bin(31),
            fixed bin(31))
     GLUTENTRY external('glutInitWindowSize');

 dcl glutMainLoop
     entry ()
     GLUTENTRY external('glutMainLoop');

 /* GLUT window sub-API. */
 dcl glutCreateWindow
     entry (char(*) varz byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutCreateWindow');

 dcl glutCreateSubWindow
     entry (fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutCreateSubWindow');

 dcl glutDestroyWindow
     entry (fixed bin(31))
     GLUTENTRY external('glutDestroyWindow');

 dcl glutPostRedisplay
     entry ()
     GLUTENTRY external('glutPostRedisplay');

 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 11 %then %do;
 dcl glutPostWindowRedisplay
     entry (fixed bin(31))
     GLUTENTRY external('glutPostWindowRedisplay');
 %end;

 dcl glutSwapBuffers
     entry ()
     GLUTENTRY external('glutSwapBuffers');

 dcl glutGetWindow
     entry ()
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutGetWindow');

 dcl glutSetWindow
     entry (fixed bin(31))
     GLUTENTRY external('glutSetWindow');

 dcl glutSetWindowTitle
     entry (char(*) varz byaddr nonasgn)
     GLUTENTRY external('glutSetWindowTitle');

 dcl glutSetIconTitle
     entry (char(*) varz byaddr nonasgn)
     GLUTENTRY external('glutSetIconTitle');

 dcl glutPositionWindow
     entry (fixed bin(31),
            fixed bin(31))
     GLUTENTRY external('glutPositionWindow');

 dcl glutReshapeWindow
     entry (fixed bin(31),
            fixed bin(31))
     GLUTENTRY external('glutReshapeWindow');

 dcl glutPopWindow
     entry ()
     GLUTENTRY external('glutPopWindow');

 dcl glutPushWindow
     entry ()
     GLUTENTRY external('glutPushWindow');

 dcl glutIconifyWindow
     entry ()
     GLUTENTRY external('glutIconifyWindow');

 dcl glutShowWindow
     entry ()
     GLUTENTRY external('glutShowWindow');

 dcl glutHideWindow
     entry ()
     GLUTENTRY external('glutHideWindow');

 %if GLUT_API_VERSION >= 3 %then %do;
 dcl glutFullScreen
     entry ()
     GLUTENTRY external('glutFullScreen');

 dcl glutSetCursor
     entry (fixed bin(31))
     GLUTENTRY external('glutSetCursor');

 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 9 %then %do;
 dcl glutWarpPointer
     entry (fixed bin(31),
            fixed bin(31))
     GLUTENTRY external('glutWarpPointer');
 %end;

 /* GLUT overlay sub-API. */
 dcl glutEstablishOverlay
     entry ()
     GLUTENTRY external('glutEstablishOverlay');

 dcl glutRemoveOverlay
     entry ()
     GLUTENTRY external('glutRemoveOverlay');

 dcl glutUseLayer
     entry (type GLenum)
     GLUTENTRY external('glutUseLayer');

 dcl glutPostOverlayRedisplay
     entry ()
     GLUTENTRY external('glutPostOverlayRedisplay');

 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 11 %then %do;
 dcl glutPostWindowOverlayRedisplay
     entry (fixed bin(31))
     GLUTENTRY external('glutPostWindowOverlayRedisplay');
 %end;

 dcl glutShowOverlay
     entry ()
     GLUTENTRY external('glutShowOverlay');

 dcl glutHideOverlay
     entry ()
     GLUTENTRY external('glutHideOverlay');
 %end;

 /* GLUT menu sub-API. */
 dcl glutCreateMenu
     entry (entry (fixed bin(31)) limited GLUTENTRY optional)
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutCreateMenu');

 dcl glutDestroyMenu
     entry (fixed bin(31))
     GLUTENTRY external('glutDestroyMenu');

 dcl glutGetMenu
     entry ()
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutGetMenu');

 dcl glutSetMenu
     entry (fixed bin(31))
     GLUTENTRY external('glutSetMenu');

 dcl glutAddMenuEntry
     entry (char(*) varz byaddr nonasgn,
            fixed bin(31))
     GLUTENTRY external('glutAddMenuEntry');

 dcl glutAddSubMenu
     entry (char(*) varz byaddr nonasgn,
            fixed bin(31))
     GLUTENTRY external('glutAddSubMenu');

 dcl glutChangeToMenuEntry
     entry (fixed bin(31),
            char(*) varz byaddr nonasgn,
            fixed bin(31))
     GLUTENTRY external('glutChangeToMenuEntry');

 dcl glutChangeToSubMenu
     entry (fixed bin(31),
            char(*) varz byaddr nonasgn,
            fixed bin(31))
     GLUTENTRY external('glutChangeToSubMenu');

 dcl glutRemoveMenuItem
     entry (fixed bin(31))
     GLUTENTRY external('glutRemoveMenuItem');

 dcl glutAttachMenu
     entry (fixed bin(31))
     GLUTENTRY external('glutAttachMenu');

 dcl glutDetachMenu
     entry (fixed bin(31))
     GLUTENTRY external('glutDetachMenu');

 /* GLUT window callback sub-API. */
 dcl glutDisplayFunc
     entry (entry () limited GLUTENTRY optional)
     GLUTENTRY external('glutDisplayFunc');

 dcl glutReshapeFunc
     entry (entry (fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutReshapeFunc');

 dcl glutKeyboardFunc
     entry (entry (char (1),
                   fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutKeyboardFunc');

 dcl glutMouseFunc
     entry (entry (fixed bin(31),
                   fixed bin(31),
                   fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutMouseFunc');

 dcl glutMotionFunc
     entry (entry (fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutMotionFunc');

 dcl glutPassiveMotionFunc
     entry (entry (fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutPassiveMotionFunc');

 dcl glutEntryFunc
     entry (entry (fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutEntryFunc');

 dcl glutVisibilityFunc
     entry (entry (fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutVisibilityFunc');

 dcl glutIdleFunc
     entry (entry () limited GLUTENTRY optional)
     GLUTENTRY external('glutIdleFunc');

 dcl glutTimerFunc
     entry (fixed bin(32) unsigned,
            entry (fixed bin(31)) limited GLUTENTRY optional,
            fixed bin(31))
     GLUTENTRY external('glutTimerFunc');

 dcl glutMenuStateFunc
     entry (entry (fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutMenuStateFunc');

 %if GLUT_API_VERSION >= 2 %then %do;
 dcl glutSpecialFunc
     entry (entry (fixed bin(31),
                   fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutSpecialFunc');

 dcl glutSpaceballMotionFunc
     entry (entry (fixed bin(31),
                   fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutSpaceballMotionFunc');

 dcl glutSpaceballRotateFunc
     entry (entry (fixed bin(31),
                   fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutSpaceballRotateFunc');

 dcl glutSpaceballButtonFunc
     entry (entry (fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutSpaceballButtonFunc');

 dcl glutButtonBoxFunc
     entry (entry (fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutButtonBoxFunc');

 dcl glutDialsFunc
     entry (entry (fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutDialsFunc');

 dcl glutTabletMotionFunc
     entry (entry (fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutTabletMotionFunc');

 dcl glutTabletButtonFunc
     entry (entry (fixed bin(31),
                   fixed bin(31),
                   fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutTabletButtonFunc');

 %if GLUT_API_VERSION >= 3 %then %do;
 dcl glutMenuStatusFunc
     entry (entry (fixed bin(31),
                   fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutMenuStatusFunc');

 dcl glutOverlayDisplayFunc
     entry (entry () limited GLUTENTRY optional)
     GLUTENTRY external('glutOverlayDisplayFunc');

 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 9 %then %do;
 dcl glutWindowStatusFunc
     entry (entry (fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutWindowStatusFunc');
 %end;

 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 13 %then %do;
 dcl glutKeyboardUpFunc
     entry (entry (char (1),
                   fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutKeyboardUpFunc');

 dcl glutSpecialUpFunc
     entry (entry (fixed bin(31),
                   fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional)
     GLUTENTRY external('glutSpecialUpFunc');

 dcl glutJoystickFunc
     entry (entry (fixed bin(32) unsigned,
                   fixed bin(31),
                   fixed bin(31),
                   fixed bin(31)) limited GLUTENTRY optional,
            fixed bin(31))
     GLUTENTRY external('glutJoystickFunc ');
 %end;
 %end;
 %end;

 /* GLUT color index sub-API. */
 dcl glutSetColor
     entry (fixed bin(31),
            type GLfloat,
            type GLfloat,
            type GLfloat)
     GLUTENTRY external('glutSetColor');

 dcl glutGetColor
     entry (fixed bin(31),
            fixed bin(31))
     returns (type GLfloat byvalue optional)
     GLUTENTRY external('glutGetColor');

 dcl glutCopyColormap
     entry (fixed bin(31))
     GLUTENTRY external('glutCopyColormap');

 /* GLUT state retrieval sub-API. */
 dcl glutGet
     entry (type GLenum)
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutGet');

 dcl glutDeviceGet
     entry (type GLenum)
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutDeviceGet');

 %if GLUT_API_VERSION >= 2 %then %do;
 /* GLUT extension support sub-API */
 dcl glutExtensionSupported
     entry (char(*) varz byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutExtensionSupported');

 %end;
 %if GLUT_API_VERSION >= 3 %then %do;
 dcl glutGetModifiers
     entry ()
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutGetModifiers');

 dcl glutLayerGet
     entry (type GLenum)
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutLayerGet');
 %end;

 /* GLUT font sub-API */
 dcl glutBitmapCharacter
     entry (pointer,       /* font */
            fixed bin(31)) /* character! */
     GLUTENTRY external('glutBitmapCharacter');

 dcl glutBitmapWidth
     entry (pointer,       /* font */
            fixed bin(31)) /* character! */
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutBitmapWidth');

 dcl glutStrokeCharacter
     entry (pointer,       /* font */
            fixed bin(31)) /* character! */
     GLUTENTRY external('glutStrokeCharacter');

 dcl glutStrokeWidth
     entry (pointer,       /* font */
            fixed bin(31)) /* character! */
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutStrokeWidth');

 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 9 %then %do;
 dcl glutBitmapLength
     entry (pointer,       /* font */
            char(*) varz byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutBitmapLength');

 dcl glutStrokeLength
     entry (pointer,       /* font */
            char(*) varz byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutStrokeLength');
 %end;

 /* GLUT pre-built models sub-API */
 dcl glutWireSphere
     entry (type GLdouble,
            type GLint,
            type GLint)
     GLUTENTRY external('glutWireSphere');

 dcl glutSolidSphere
     entry (type GLdouble,
            type GLint,
            type GLint)
     GLUTENTRY external('glutSolidSphere');

 dcl glutWireCone
     entry (type GLdouble,
            type GLdouble,
            type GLint,
            type GLint)
     GLUTENTRY external('glutWireCone');

 dcl glutSolidCone
     entry (type GLdouble,
            type GLdouble,
            type GLint,
            type GLint)
     GLUTENTRY external('glutSolidCone');

 dcl glutWireCube
     entry (type GLdouble)
     GLUTENTRY external('glutWireCube');

 dcl glutSolidCube
     entry (type GLdouble)
     GLUTENTRY external('glutSolidCube');

 dcl glutWireTorus
     entry (type GLdouble,
            type GLdouble,
            type GLint,
            type GLint)
     GLUTENTRY external('glutWireTorus');

 dcl glutSolidTorus
     entry (type GLdouble,
            type GLdouble,
            type GLint,
            type GLint)
     GLUTENTRY external('glutSolidTorus');

 dcl glutWireDodecahedron
     entry ()
     GLUTENTRY external('glutWireDodecahedron');

 dcl glutSolidDodecahedron
     entry ()
     GLUTENTRY external('glutSolidDodecahedron');

 dcl glutWireTeapot
     entry (type GLdouble)
     GLUTENTRY external('glutWireTeapot');

 dcl glutSolidTeapot
     entry (type GLdouble)
     GLUTENTRY external('glutSolidTeapot');

 dcl glutWireOctahedron
     entry ()
     GLUTENTRY external('glutWireOctahedron');

 dcl glutSolidOctahedron
     entry ()
     GLUTENTRY external('glutSolidOctahedron');

 dcl glutWireTetrahedron
     entry ()
     GLUTENTRY external('glutWireTetrahedron');

 dcl glutSolidTetrahedron
     entry ()
     GLUTENTRY external('glutSolidTetrahedron');

 dcl glutWireIcosahedron
     entry ()
     GLUTENTRY external('glutWireIcosahedron');

 dcl glutSolidIcosahedron
     entry ()
     GLUTENTRY external('glutSolidIcosahedron');

 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 9 %then %do;
 /* GLUT video resize sub-API. */
 dcl glutVideoResizeGet
     entry (type GLenum)
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutVideoResizeGet');

 dcl glutSetupVideoResizing
     entry ()
     GLUTENTRY external('glutSetupVideoResizing');

 dcl glutStopVideoResizing
     entry ()
     GLUTENTRY external('glutStopVideoResizing');

 dcl glutVideoResize
     entry (fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     GLUTENTRY external('glutVideoResize');

 dcl glutVideoPan
     entry (fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     GLUTENTRY external('glutVideoPan');

 /* GLUT debugging sub-API. */
 dcl glutReportErrors
     entry ()
     GLUTENTRY external('glutReportErrors');
 %end;

 %if GLUT_API_VERSION >= 4 | GLUT_XLIB_IMPLEMENTATION >= 13 %then %do;
 /* GLUT device control sub-API. */
 /* glutSetKeyRepeat modes. */
 dcl GLUT_KEY_REPEAT_OFF            fixed bin(31) value(0);
 dcl GLUT_KEY_REPEAT_ON             fixed bin(31) value(1);
 dcl GLUT_KEY_REPEAT_DEFAULT        fixed bin(31) value(2);

 /* Joystick button masks. */
 dcl GLUT_JOYSTICK_BUTTON_A         fixed bin(31) value(1);
 dcl GLUT_JOYSTICK_BUTTON_B         fixed bin(31) value(2);
 dcl GLUT_JOYSTICK_BUTTON_C         fixed bin(31) value(4);
 dcl GLUT_JOYSTICK_BUTTON_D         fixed bin(31) value(8);

 dcl glutIgnoreKeyRepeat
     entry (fixed bin(31))
     GLUTENTRY external('glutIgnoreKeyRepeat');

 dcl glutSetKeyRepeat
     entry (fixed bin(31))
     GLUTENTRY external('glutSetKeyRepeat');

 dcl glutForceJoystickFunc
     entry ()
     GLUTENTRY external('glutForceJoystickFunc');

 /* GLUT game mode sub-API. */
 /* glutGameModeGet. */
 dcl GLUT_GAME_MODE_ACTIVE          fixed bin(31) value(0);
 dcl GLUT_GAME_MODE_POSSIBLE        fixed bin(31) value(1);
 dcl GLUT_GAME_MODE_WIDTH           fixed bin(31) value(2);
 dcl GLUT_GAME_MODE_HEIGHT          fixed bin(31) value(3);
 dcl GLUT_GAME_MODE_PIXEL_DEPTH     fixed bin(31) value(4);
 dcl GLUT_GAME_MODE_REFRESH_RATE    fixed bin(31) value(5);
 dcl GLUT_GAME_MODE_DISPLAY_CHANGED fixed bin(31) value(6);

 dcl glutGameModeString
     entry (char(*) varz byaddr nonasgn)
     GLUTENTRY external('glutGameModeString');

 dcl glutEnterGameMode
     entry ()
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutEnterGameMode');

 dcl glutLeaveGameMode
     entry ()
     GLUTENTRY external('glutLeaveGameMode');

 dcl glutGameModeGet
     entry (type GLenum)
     returns (fixed bin(31) byvalue optional)
     GLUTENTRY external('glutGameModeGet');
 %end;
 %end; /* __glut_h__ */
