 /* functions to get shell special folders                            */
 /* shfolder.dll supports these on all platforms including Win95,     */
 /* Win98, NT4 and IE4 shell                                          */

 /* all CSIDL values refered to here are supported natively by        */
 /* shfolder.dll, that is they will work on all platforms.            */

 %dcl #SHFOLDER_H_ char ext;
 %if #SHFOLDER_H_ = '' %then %do;
 %#SHFOLDER_H_ = 'Y';

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;

 %dcl UNICODE char ext;

 %dcl CSIDL_PERSONAL# char ext;
 %if CSIDL_PERSONAL# = '' %then %do;
 %CSIDL_PERSONAL# = 'Y';
 dcl CSIDL_PERSONAL         fixed bin(31) value('0005'xn);
     /* My Documents */
 %end;

 %dcl CSIDL_MYMUSIC# char ext;
 %if CSIDL_MYMUSIC# = '' %then %do;
 %CSIDL_MYMUSIC# = 'Y';
 dcl CSIDL_MYMUSIC          fixed bin(31) value('000d'xn);
     /* "My Music" folder */
 %end;


 %dcl CSIDL_APPDATA# char ext;
 %if CSIDL_APPDATA# = '' %then %do;
 %CSIDL_APPDATA# = 'Y';
 dcl CSIDL_APPDATA          fixed bin(31) value('001A'xn);
     /* Application Data, new for NT4 */
 %end;

 %dcl CSIDL_LOCAL_APPDATA# char ext;
 %if CSIDL_LOCAL_APPDATA# = '' %then %do;
 %CSIDL_LOCAL_APPDATA# = 'Y';

 dcl CSIDL_LOCAL_APPDATA        fixed bin(31) value('001C'xn);
     /* non roaming, user\Local Settings\Application Data */
 dcl CSIDL_INTERNET_CACHE       fixed bin(31) value('0020'xn);
 dcl CSIDL_COOKIES              fixed bin(31) value('0021'xn);
 dcl CSIDL_HISTORY              fixed bin(31) value('0022'xn);
 dcl CSIDL_COMMON_APPDATA       fixed bin(31) value('0023'xn);
     /* All Users\Application Data */
 dcl CSIDL_WINDOWS              fixed bin(31) value('0024'xn);
     /* GetWindowsDirectory() */
 dcl CSIDL_SYSTEM               fixed bin(31) value('0025'xn);
     /* GetSystemDirectory() */
 dcl CSIDL_PROGRAM_FILES        fixed bin(31) value('0026'xn);
     /* C:\Program Files */
 dcl CSIDL_MYPICTURES           fixed bin(31) value('0027'xn);
     /* My Pictures, new for NT5 */
 dcl CSIDL_PROGRAM_FILES_COMMON fixed bin(31) value('002b'xn);
     /* C:\Program Files\Common */
 dcl CSIDL_COMMON_DOCUMENTS     fixed bin(31) value('002e'xn);
     /* All Users\Documents */
 dcl CSIDL_RESOURCES            fixed bin(31) value('0038'xn);
     /* %windir%\Resources\, For theme and other windows resources. */
 dcl CSIDL_RESOURCES_LOCALIZED  fixed bin(31) value('0039'xn);
     /* %windir%\Resources\<LangID>, for theme and other windows    */
     /* specific resources.                                         */

 dcl CSIDL_FLAG_CREATE          fixed bin(31) value('8000'xn);
     /* new for NT5, or this in to force creation of folder */

 dcl CSIDL_COMMON_ADMINTOOLS    fixed bin(31) value('002f'xn);
     /* All Users\Start Menu\Programs\Administrative Tools */
 dcl CSIDL_ADMINTOOLS           fixed bin(31) value('0030'xn);
     /* <user name>\Start Menu\Programs\Administrative Tools */
 %end; /* CSIDL_LOCAL_APPDATA */


 dcl SHGetFolderPathA
     entry (type HWND,
            fixed bin(31),
            type HANDLE,
            type DWORD,
            char(*) varz byaddr)
     STDAPI external('SHGetFolderPathA');
 dcl SHGetFolderPathW
     entry (type HWND,
            fixed bin(31),
            type HANDLE,
            type DWORD,
            WCHAR(*) varz byaddr)
     STDAPI external('SHGetFolderPathW');

 /* protos so callers can GetProcAddress() from shfolder.dll */

 define alias PFNSHGETFOLDERPATHA
        entry (type HWND,
               fixed bin(31),
               type HANDLE,
               type DWORD,
               char(*) varz byaddr)
        returns (type HRESULT byvalue optional)
        limited options (byvalue linkage(stdcall) nodescriptor);
 define alias PFNSHGETFOLDERPATHW
        entry (type HWND,
               fixed bin(31),
               type HANDLE,
               type DWORD,
               WCHAR(*) varz byaddr)
        returns (type HRESULT byvalue optional)
        limited options (byvalue linkage(stdcall) nodescriptor);

 %dcl SHGetFolderPath char ext;
 %dcl PFNSHGETFOLDERPATH char ext;
 %if UNICODE ^= '' %then %do;
   %SHGetFolderPath='SHGetFolderPathW';
   %PFNSHGETFOLDERPATH='PFNSHGETFOLDERPATHW';
 %end; %else %do;
   %SHGetFolderPath='SHGetFolderPathA';
   %PFNSHGETFOLDERPATH='PFNSHGETFOLDERPATHA';
 %end;

 %end; /* _SHFOLDER_H_ */
