 /*++ BUILD Version: 0001    -- Increment this if a change has global */
 /*                             effects                               */
 /*                                                                   */
 /* Copyright (c) 1991-1999 Microsoft Corporation                     */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     Winreg.cpy                                                    */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     This module contains the function prototypes and constant,    */
 /*     type and structure definitions for the Windows 32-Bit         */
 /*     Registry API.                                                 */
 /*                                                                   */
 /*--                                                                 */

 %dcl #WINREG_ char ext;
 %if #WINREG_ = '' %then %do;
 %#WINREG_ = 'Y';


 %dcl WINVER fixed ext;
 %if WINVER = 0 %then %do;
 %WINVER = 1280; /* version 5.0 */
 %end; /* !WINVER */

 /* Pull in WINBASE.CPY if necessary */
 %dcl #WINBASE_ char ext;
 %if #WINBASE_ = '' %then %do;
   %include winbase;
 %end;

 %dcl UNICODE char ext;


 /* Requested Key access mask type. */

 define alias REGSAM type ACCESS_MASK;

 /*  HKEY declaration moved to WINNT.CPY */
 define alias PHKEY pointer;


 /* Reserved Key Handles. */

 dcl HKEY_CLASSES_ROOT     type HKEY  value(ptrvalue('80000000'xn));
 dcl HKEY_CURRENT_USER     type HKEY  value(ptrvalue('80000001'xn));
 dcl HKEY_LOCAL_MACHINE    type HKEY  value(ptrvalue('80000002'xn));
 dcl HKEY_USERS            type HKEY  value(ptrvalue('80000003'xn));
 dcl HKEY_PERFORMANCE_DATA type HKEY  value(ptrvalue('80000004'xn));
 %if WINVER >= 1024  %then %do;
 dcl HKEY_CURRENT_CONFIG   type HKEY  value(ptrvalue('80000005'xn));
 dcl HKEY_DYN_DATA         type HKEY  value(ptrvalue('80000006'xn));

 %dcl #PROVIDER_STRUCTS_DEFINED char ext;
 %if #PROVIDER_STRUCTS_DEFINED = '' %then %do;
 %#PROVIDER_STRUCTS_DEFINED = 'Y';

 dcl PROVIDER_KEEPS_VALUE_LENGTH fixed bin(31) value(1);

 define structure
   1 val_context,
     2 valuelen      fixed bin(31),/* the total length of this value  */
     2 value_context type LPVOID,  /* provider's context              */
     2 val_buff_ptr  type LPVOID;  /* where in the output buffer the  */
                                   /* value is.                       */
 define alias PVALCONTEXT handle val_context;


 define structure
   1 PVALUEA,   /* Provider supplied value/context. */
     2 pv_valuename     type LPSTR,/* The value name pointer */
     2 pv_valuelen      fixed bin(31),
     2 pv_value_context type LPVOID,
     2 pv_type          type DWORD;
 define alias PPVALUEA handle PVALUEA;

 define structure
   1 PVALUEW,   /* Provider supplied value/context. */
     2 pv_valuename     type LPWSTR,/* The value name pointer */
     2 pv_valuelen      fixed bin(31),
     2 pv_value_context type LPVOID,
     2 pv_type          type DWORD;
 define alias PPVALUEW handle PVALUEW;

 %if UNICODE ^= '' %then %do;
   define alias  PVALUE type  PVALUEW;
   define alias PPVALUE type PPVALUEW;
 %end; %else %do;
   define alias  PVALUE type  PVALUEA;
   define alias PPVALUE type PPVALUEA;
 %end; /* UNICODE */


 define alias PQUERYHANDLER
              entry (type LPVOID,
                     type val_context byaddr,
                     type DWORD,
                     type LPVOID,
                     type DWORD byaddr,
                     type DWORD)
              returns (type DWORD byvalue optional)
              options (byvalue nodescriptor linkage(cdecl));

 define structure
   1 provider_info,
     2 pi_R0_1val     type PQUERYHANDLER,
     2 pi_R0_allvals  type PQUERYHANDLER,
     2 pi_R3_1val     type PQUERYHANDLER,
     2 pi_R3_allvals  type PQUERYHANDLER,
     2 pi_flags       type DWORD,
                      /* capability flags (none defined yet). */
     2 pi_key_context type LPVOID;

 define alias REG_PROVIDER type provider_info;
 define alias PPROVIDER    handle provider_info;

 define structure
   1 value_entA,
     2 ve_valuename type LPSTR,
     2 ve_valuelen  type DWORD,
     2 ve_valueptr  type DWORD,
     2 ve_type      type DWORD;
 define alias  VALENTA type value_entA;
 define alias PVALENTA handle value_entA;

 define structure
   1 value_entW,
     2 ve_valuename type LPWSTR,
     2 ve_valuelen  type DWORD,
     2 ve_valueptr  type DWORD,
     2 ve_type      type DWORD;
 define alias  VALENTW type value_entW;
 define alias PVALENTW handle value_entW;

 %if UNICODE ^= '' %then %do;
   define alias  VALENT type  VALENTW;
   define alias PVALENT type PVALENTW;
 %end; %else %do;
   define alias  VALENT type  VALENTA;
   define alias PVALENT type PVALENTA;
 %end; /* UNICODE */

 %end; /* not(_PROVIDER_STRUCTS_DEFINED) */

 %end; /* WINVER >= 0x0400 */

 /* Default values for parameters that do not exist in the Win 3.1 */
 /* compatible APIs.                                               */

 %dcl WIN31_CLASS char ext;
 %WIN31_CLASS='* /* omitted */';


 /* API Prototypes. */

 dcl RegCloseKey
     entry (type HKEY)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegCloseKey');

 dcl RegOverridePredefKey
     entry (type HKEY,
            type HKEY)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegOverridePredefKey');

 dcl RegOpenUserClassesRoot
     entry (type HANDLE,
            type DWORD,
            type REGSAM,
            type HKEY  byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegOpenUserClassesRoot');

 dcl RegOpenCurrentUser
     entry (type REGSAM,
            type HKEY  byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegOpenCurrentUser');

 dcl RegConnectRegistryA
     entry (char(*) varz byaddr,
            type HKEY,
            type HKEY byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegConnectRegistryA');

 dcl RegConnectRegistryW
     entry (WCHAR(*) varz byaddr,
            type HKEY,
            type HKEY byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegConnectRegistryW');

 %dcl RegConnectRegistry char ext;
 %if UNICODE ^= '' %then %do;
   %RegConnectRegistry='RegConnectRegistryW';
 %end; %else %do;
   %RegConnectRegistry='RegConnectRegistryA';
 %end; /* !UNICODE */


 dcl RegCreateKeyA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            type HKEY byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegCreateKeyA');

 dcl RegCreateKeyW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            type HKEY byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegCreateKeyW');

 %dcl RegCreateKey char ext;
 %if UNICODE ^= '' %then %do;
   %RegCreateKey='RegCreateKeyW';
 %end; %else %do;
   %RegCreateKey='RegCreateKeyA';
 %end; /* !UNICODE */


 dcl RegCreateKeyExA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            type DWORD, /* reserved */
            char(*) varz byaddr optional,
            type DWORD,
            type REGSAM,
            type SECURITY_ATTRIBUTES byaddr optional,
            type HKEY byaddr,
            type DWORD byaddr optional)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegCreateKeyExA');

 dcl RegCreateKeyExW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD, /* reserved */
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type REGSAM,
            type SECURITY_ATTRIBUTES byaddr optional,
            type HKEY byaddr,
            type DWORD byaddr optional)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegCreateKeyExW');

 %dcl RegCreateKeyEx char ext;
 %if UNICODE ^= '' %then %do;
   %RegCreateKeyEx='RegCreateKeyExW';
 %end; %else %do;
   %RegCreateKeyEx='RegCreateKeyExA';
 %end; /* !UNICODE */


 dcl RegDeleteKeyA
     entry (type HKEY,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegDeleteKeyA');

 dcl RegDeleteKeyW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegDeleteKeyW');

 %dcl RegDeleteKey char ext;
 %if UNICODE ^= '' %then %do;
   %RegDeleteKey='RegDeleteKeyW';
 %end; %else %do;
   %RegDeleteKey='RegDeleteKeyA';
 %end; /* !UNICODE */


 dcl RegDeleteValueA
     entry (type HKEY,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegDeleteValueA');

 dcl RegDeleteValueW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegDeleteValueW');

 %dcl RegDeleteValue char ext;
 %if UNICODE ^= '' %then %do;
   %RegDeleteValue='RegDeleteValueW';
 %end; %else %do;
   %RegDeleteValue='RegDeleteValueA';
 %end; /* !UNICODE */


 dcl RegEnumKeyA
     entry (type HKEY,
            type DWORD,
            char(*) varz byaddr,
            type DWORD)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegEnumKeyA');

 dcl RegEnumKeyW
     entry (type HKEY,
            type DWORD,
            WCHAR(*) varz byaddr,
            type DWORD)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegEnumKeyW');

 %dcl RegEnumKey char ext;
 %if UNICODE ^= '' %then %do;
   %RegEnumKey='RegEnumKeyW';
 %end; %else %do;
   %RegEnumKey='RegEnumKeyA';
 %end; /* !UNICODE */


 dcl RegEnumKeyExA
     entry (type HKEY,
            type DWORD,
            char(*) varz byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional, /* reserved */
            char(*) varz byaddr,
            type DWORD byaddr,
            type FILETIME byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegEnumKeyExA');

 dcl RegEnumKeyExW
     entry (type HKEY,
            type DWORD,
            WCHAR(*) varz byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional, /* reserved */
            WCHAR(*) varz byaddr,
            type DWORD byaddr,
            type FILETIME byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegEnumKeyExW');

 %dcl RegEnumKeyEx char ext;
 %if UNICODE ^= '' %then %do;
   %RegEnumKeyEx='RegEnumKeyExW';
 %end; %else %do;
   %RegEnumKeyEx='RegEnumKeyExA';
 %end; /* !UNICODE */


 dcl RegEnumValueA
     entry (type HKEY,
            type DWORD,
            char(*) varz byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional, /* reserved */
            type DWORD byaddr,
            type LPBYTE,  /* buffer for result, or sysnull() */
            type DWORD byaddr optional)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegEnumValueA');

 dcl RegEnumValueW
     entry (type HKEY,
            type DWORD,
            WCHAR(*) varz byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional, /* reserved */
            type DWORD byaddr,
            type LPBYTE,  /* buffer for result, or sysnull() */
            type DWORD byaddr optional)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegEnumValueW');

 %dcl RegEnumValue char ext;
 %if UNICODE ^= '' %then %do;
   %RegEnumValue='RegEnumValueW';
 %end; %else %do;
   %RegEnumValue='RegEnumValueA';
 %end; /* !UNICODE */


 dcl RegFlushKey
     entry (type HKEY)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegFlushKey');


 dcl RegGetKeySecurity
     entry (type HKEY,
            type SECURITY_INFORMATION,
            type PSECURITY_DESCRIPTOR,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegGetKeySecurity');


 dcl RegLoadKeyA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegLoadKeyA');

 dcl RegLoadKeyW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegLoadKeyW');

 %dcl RegLoadKey char ext;
 %if UNICODE ^= '' %then %do;
   %RegLoadKey='RegLoadKeyW';
 %end; %else %do;
   %RegLoadKey='RegLoadKeyA';
 %end; /* !UNICODE */


 dcl RegNotifyChangeKeyValue
     entry (type HKEY,
            type BOOL,
            type DWORD,
            type HANDLE,
            type BOOL)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegNotifyChangeKeyValue');


 dcl RegOpenKeyA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            type HKEY byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegOpenKeyA');

 dcl RegOpenKeyW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            type HKEY byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegOpenKeyW');

 %dcl RegOpenKey char ext;
 %if UNICODE ^= '' %then %do;
   %RegOpenKey='RegOpenKeyW';
 %end; %else %do;
   %RegOpenKey='RegOpenKeyA';
 %end; /* !UNICODE */


 dcl RegOpenKeyExA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type REGSAM,
            type HKEY byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegOpenKeyExA');

 dcl RegOpenKeyExW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type REGSAM,
            type HKEY byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegOpenKeyExW');

 %dcl RegOpenKeyEx char ext;
 %if UNICODE ^= '' %then %do;
   %RegOpenKeyEx='RegOpenKeyExW';
 %end; %else %do;
   %RegOpenKeyEx='RegOpenKeyExA';
 %end; /* !UNICODE */


 dcl RegQueryInfoKeyA
     entry (type HKEY,
            char(*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD byaddr optional, /* reserved */
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type FILETIME byaddr optional)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegQueryInfoKeyA');

 dcl RegQueryInfoKeyW
     entry (type HKEY,
            WCHAR(*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD byaddr optional, /* reserved */
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type DWORD byaddr optional,
            type FILETIME byaddr optional)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegQueryInfoKeyW');

 %dcl RegQueryInfoKey char ext;
 %if UNICODE ^= '' %then %do;
   %RegQueryInfoKey='RegQueryInfoKeyW';
 %end; %else %do;
   %RegQueryInfoKey='RegQueryInfoKeyA';
 %end; /* !UNICODE */


 dcl RegQueryValueA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr,
            type LONG byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegQueryValueA');

 dcl RegQueryValueW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr,
            type LONG byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegQueryValueW');

 %dcl RegQueryValue char ext;
 %if UNICODE ^= '' %then %do;
   %RegQueryValue='RegQueryValueW';
 %end; %else %do;
   %RegQueryValue='RegQueryValueA';
 %end; /* !UNICODE */

 %dcl WINVER fixed ext;
 %if WINVER >= 1024  %then %do;

 dcl RegQueryMultipleValuesA  entry (
        type HKEY,
        (*) type VALENTA byaddr,
        type DWORD,
        pointer, /* to buffer, or sysnull() */
        type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegQueryMultipleValuesA');

 dcl RegQueryMultipleValuesW  entry (
        type HKEY,
        (*) type VALENTW byaddr,
        type DWORD,
        pointer, /* to buffer, or sysnull() */
        type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegQueryMultipleValuesW');

 %dcl RegQueryMultipleValues char ext;
 %if UNICODE ^= '' %then %do;
   %RegQueryMultipleValues='RegQueryMultipleValuesW';
 %end; %else %do;
   %RegQueryMultipleValues='RegQueryMultipleValuesA';
 %end; /* !UNICODE */
 %end; /* WINVER >= 0x0400 */


 dcl RegQueryValueExA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            type DWORD byaddr optional, /* reserved */
            type DWORD byaddr optional,
            type LPBYTE,
            type DWORD byaddr optional)
    returns (type LONG byvalue optional)
    WINADVAPI APIENTRY external('RegQueryValueExA');

 dcl RegQueryValueExW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD byaddr optional, /* reserved */
            type DWORD byaddr optional,
            type LPBYTE,
            type DWORD byaddr optional)
    returns (type LONG byvalue optional)
    WINADVAPI APIENTRY external('RegQueryValueExW');

 %dcl RegQueryValueEx char ext;
 %if UNICODE ^= '' %then %do;
   %RegQueryValueEx='RegQueryValueExW';
 %end; %else %do;
   %RegQueryValueEx='RegQueryValueExA';
 %end; /* !UNICODE */


 dcl RegReplaceKeyA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegReplaceKeyA');

 dcl RegReplaceKeyW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegReplaceKeyW');

 %dcl RegReplaceKey char ext;
 %if UNICODE ^= '' %then %do;
   %RegReplaceKey='RegReplaceKeyW';
 %end; %else %do;
   %RegReplaceKey='RegReplaceKeyA';
 %end; /* !UNICODE */


 dcl RegRestoreKeyA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegRestoreKeyA');

 dcl RegRestoreKeyW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegRestoreKeyW');

 %dcl RegRestoreKey char ext;
 %if UNICODE ^= '' %then %do;
   %RegRestoreKey='RegRestoreKeyW';
 %end; %else %do;
   %RegRestoreKey='RegRestoreKeyA';
 %end; /* !UNICODE */


 dcl RegSaveKeyA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            type SECURITY_ATTRIBUTES byaddr optional)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegSaveKeyA');

 dcl RegSaveKeyW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            type SECURITY_ATTRIBUTES byaddr optional)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegSaveKeyW');

 %dcl RegSaveKey char ext;
 %if UNICODE ^= '' %then %do;
   %RegSaveKey='RegSaveKeyW';
 %end; %else %do;
 %dcl RegSaveKey char ext;
   %RegSaveKey='RegSaveKeyA';
 %end; /* !UNICODE */


 dcl RegSetKeySecurity
     entry (type HKEY,
            type SECURITY_INFORMATION,
            type PSECURITY_DESCRIPTOR)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegSetKeySecurity');


 dcl RegSetValueA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            type DWORD,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegSetValueA');

 dcl RegSetValueW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegSetValueW');

 %dcl RegSetValue char ext;
 %if UNICODE ^= '' %then %do;
   %RegSetValue='RegSetValueW';
 %end; %else %do;
   %RegSetValue='RegSetValueA';
 %end; /* !UNICODE */


 dcl RegSetValueExA
     entry (type HKEY,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            pointer,    /* to value */
            type DWORD)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegSetValueExA');

 dcl RegSetValueExW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            pointer,    /* to value */
            type DWORD)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegSetValueExW');

 %dcl RegSetValueEx char ext;
 %if UNICODE ^= '' %then %do;
   %RegSetValueEx='RegSetValueExW';
 %end; %else %do;
   %RegSetValueEx='RegSetValueExA';
 %end; /* !UNICODE */


 dcl RegUnLoadKeyA
     entry (type HKEY,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegUnLoadKeyA');

 dcl RegUnLoadKeyW
     entry (type HKEY,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINADVAPI APIENTRY external('RegUnLoadKeyW');

 %dcl RegUnLoadKey char ext;
 %if UNICODE ^= '' %then %do;
   %RegUnLoadKey='RegUnLoadKeyW';
 %end; %else %do;
   %RegUnLoadKey='RegUnLoadKeyA';
 %end; /* !UNICODE */


 /* Remoteable System Shutdown APIs */

 dcl InitiateSystemShutdownA
     entry (char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            type DWORD,
            type BOOL,
            type BOOL)
     returns (type BOOL byvalue optional)
     WINADVAPI APIENTRY external('InitiateSystemShutdownA');

 dcl InitiateSystemShutdownW
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type BOOL,
            type BOOL)
     returns (type BOOL byvalue optional)
     WINADVAPI APIENTRY external('InitiateSystemShutdownW');

 %dcl InitiateSystemShutdown char ext;
 %if UNICODE ^= '' %then %do;
   %InitiateSystemShutdown='InitiateSystemShutdownW';
 %end; %else %do;
   %InitiateSystemShutdown='InitiateSystemShutdownA';
 %end; /* !UNICODE */


 dcl AbortSystemShutdownA
     entry (char(*) varz byaddr optional)
     returns (type BOOL byvalue optional)
     WINADVAPI APIENTRY external('AbortSystemShutdownA');

 dcl AbortSystemShutdownW
     entry (WCHAR(*) varz byaddr optional)
     returns (type BOOL byvalue optional)
     WINADVAPI APIENTRY external('AbortSystemShutdownW');

 %dcl AbortSystemShutdown char ext;
 %if UNICODE ^= '' %then %do;
   %AbortSystemShutdown='AbortSystemShutdownW';
 %end; %else %do;
   %AbortSystemShutdown='AbortSystemShutdownA';
 %end; /* !UNICODE */

 /* defines for InitiateSystemShutdownEx reason codes */

 dcl REASON_SWINSTALL    type DWORD value(0);
 dcl REASON_HWINSTALL    type DWORD value(1);
 dcl REASON_SERVICEHANG  type DWORD value(2);
 dcl REASON_UNSTABLE     type DWORD value(3);
 dcl REASON_SWHWRECONF   type DWORD value(4);
 dcl REASON_OTHER        type DWORD value(5);
 dcl REASON_UNKNOWN      type DWORD value(255);
 dcl REASON_PLANNED_FLAG type DWORD value('80000000'xu);

 dcl InitiateSystemShutdownExA
     entry (char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            type DWORD,
            type BOOL,
            type BOOL,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINADVAPI APIENTRY external('InitiateSystemShutdownExA');

 dcl InitiateSystemShutdownExW
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type BOOL,
            type BOOL,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINADVAPI APIENTRY external('InitiateSystemShutdownExW');

 %dcl InitiateSystemShutdownEx char ext;
 %if UNICODE ^= '' %then %do;
   %InitiateSystemShutdownEx='InitiateSystemShutdownExW';
 %end; %else %do;
   %InitiateSystemShutdownEx='InitiateSystemShutdownExA';
 %end; /* !UNICODE */

 %end; /* #WINREG_ */
