 /*********************************************************************/
 /*  XCMCMSXT.CPY                                                     */
 /*                                                                   */
 /*  Purpose:                                                         */
 /*  Specifies constants and data structures for Microsoft CMC        */
 /*  extension set                                                    */
 /*********************************************************************/

 %dcl XCMCMSXT_H char ext;
 %if XCMCMSXT_H = '' %then %do;
 %XCMCMSXT_H = 'Y';


 /*********************************************************************/
 /*  Warning: Value for MS_EXT_SET_ID has not been finalized yet.     */
 /*********************************************************************/
 dcl MS_EXT_SET_ID fixed bin(31) value(512);

 dcl CMC_XS_MS               type CMC_uint32 value(MS_EXT_SET_ID);

 /*** FUNCTION EXTENSIONS ***/

 /* Describes extra flags used for logging on/off a session */
 dcl CMC_X_MS_SESSION_FLAGS  type CMC_uint32 value(MS_EXT_SET_ID + 16);
 dcl CMC_X_MS_NEW_SESSION    type CMC_flags value(1);
 dcl CMC_X_MS_FORCE_DOWNLOAD type CMC_flags value(4);

 /* Flags used by various functions */
 dcl CMC_X_MS_FUNCTION_FLAGS type CMC_uint32 value(MS_EXT_SET_ID + 17);
 dcl CMC_X_MS_READ_ENV_ONLY       type CMC_flags value(1);
 dcl CMC_X_MS_READ_BODY_AS_FILE   type CMC_flags value(2);
 dcl CMC_X_MS_LIST_GUARANTEE_FIFO type CMC_flags value(4);
 dcl CMC_X_MS_AB_NO_MODIFY        type CMC_flags value(8);

 /* Extra options when displaying the Address Book UI */
 dcl CMC_X_MS_ADDRESS_UI     type CMC_uint32 value(MS_EXT_SET_ID + 18);

 /*** DATA EXTENSIONS ***/

 /* Extra flags for attachments */
 dcl CMC_X_MS_ATTACH_DATA    type CMC_uint32 value(MS_EXT_SET_ID + 128);
 dcl CMC_X_MS_ATTACH_OLE        type CMC_flags value(1);
 dcl CMC_X_MS_ATTACH_OLE_STATIC type CMC_flags value(2);

 /* Extra data for messages */
 dcl CMC_X_MS_MESSAGE_DATA   type CMC_uint32 value(MS_EXT_SET_ID + 129);
 dcl CMC_X_MS_MSG_RECEIPT_REQ type CMC_flags value(1);

 %end; /* XCMCMSXT_H */
